/* Slave program */

#include <stdio.h>
#include <string.h>
#include <math.h>
#include "pvm3.h"

#define 	PROC 4
#define		X_RESN	800       /* x resolution */
#define		Y_RESN	800       /* y resolution */

typedef struct complextype
	{
        float real, imag;
	} Compl;


main ()
{
	int mytid;              /* my task id */
	int nproc;              /* number of processes */
	int tids[PROC];

	unsigned
	int x, y;               /* window position */

   /* Mandlebrot variables */
   int i, j, k, row, me, master, NumberOfElements;
   Compl	z, c;
   float	lengthsq, temp;

	/*Receiving and Getting Data*/
	mytid = pvm_mytid();
	pvm_recv(-1, 0);
	pvm_upkint(tids, 10, 1);
	pvm_upkint(NumberOfElements, 1, 1);

	master = pvm_parent();
   /*Finding Myself!*/
   for(i=0;i<10;++i)
   {
     if (mytid = tids[i])
     {
       me = i ;
       break ;
     }
   }

   /* Calculations*/

	for(x=me*NumberOfElements; x < (me+1)*NumberOfElements; x++)
		for(y=row; y < Y_RESN; y++)
		{
			z.real = z.imag = 0.0;
			c.real = ((float) y - 400.0)/200.0;
			c.imag = ((float) x - 400.0)/200.0;
			k = 0;
			do
			{
				temp = z.real*z.real - z.imag*z.imag + c.real;
				z.imag = 2.0*z.real*z.imag + c.imag;
				z.real = temp;
				lengthsq = z.real*z.real+z.imag*z.imag;
				k++;
			}while (lengthsq < 4.0 && k < 256);
         
         /*Sending data*/
			pvm_initsend(PvmDataDefault);
			pvm_pkint(&x, 1, 1);
			pvm_pkint(&y, 1, 1);
			pvm_pkint(&k, 1, 1);
			pvm_send(master, 2);   /* send coords, color to master */
		}

	pvm_exit();
	/*Exiting Pvm*/
	return(0);
}

