#include <stdio.h>
#include <stdlib.h>
#include <pvm3.h>

#define SLAVENAME "sucollapse"
#define PROC 10
#define NELEM 1000

main()
  {
  int mytid ;                  /* my task id */
  int tids[ PROC ] ;           /* slave task ids */
  int n = NELEM ;              /* number of data elements */
  int nproc = PROC ;           /* number of processes */
  int numt, i, j, who, msgtype ;
  int data[ 100 ] ;            /* data array */
  int tot = 0;                 /* total sum of data elements */
  char fn[ 255 ] ;             /* array used for path name */
  FILE *fp;                    /* pointer to the input file */
  int maxs[PROC];              /* holds the maxs from each slave */ 
  int tempmax ;                /* holds the maximum number ever found */

  /* Enroll In PVM */
  mytid = pvm_mytid() ;

  /* Start Slave Tasks */
  numt = pvm_spawn( SLAVENAME, (char**)0, 0, "", nproc, tids ) ;
  if ( numt < nproc )
    {
      printf( "Trouble spawning slaves. Aborting. Error codes are: \n" ) ;
      for ( i=numt ; i<nproc ; i++ )
        printf( "TID %d %d\n", i, tids[ i ] ) ;
      for ( i = 0 ; i < numt ; i++ )
        pvm_kill( tids[ i ] ) ;
      pvm_exit() ;
      exit( 1 ) ;
    }

  /* Get Proper Path For Input File */
  strcpy( fn, getenv( "HOME" ) ) ;
  strcat( fn, "/pvm3/bin/SUN4SOL2/rand_data.txt" ) ;
  
  /* Open Input File and Initialize Data */
  if ( ( fp = fopen( fn, "r" ) ) == NULL )
    {
      printf("Can't open the input file: %s\n\n", fn);
      exit(1);
    }
  for ( i=0; i<10; i++ )
  {
    for( j=0; j<100;++j)
    {
      fscanf( fp, "%d", &data[ j ] ) ;
    }
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data, 100, 1);
    pvm_pkint(tids, 10, 1);
    pvm_send(tids[i],1);
  }
  fclose(fp);
  /* Wait For Results From The Slaves */
  strcpy(fn,getenv("HOME"));
  strcat(fn, "/output.txt");
  fp = fopen(fn,"w");
  msgtype = 5 ;
  for ( i=0; i < 10; i++ )
  {
      printf("\nHenuz data yakalanamadi.");
      pvm_recv(-1, msgtype);
      printf("\nHenuz data yakalandi.");
      pvm_upkint(&who, 1, 1);
      pvm_upkint(data, 100, 1);
      fprintf(fp,"\n%d . processors data\n ",who);
      for(j=0;j<100;++j)
      {
        fprintf(fp,"%d",data[j]);
      }
  }

  printf ( "The operation has been finished\n") ;

  /* Program Finished. Exit PVM */
  pvm_exit() ;
  return( 0 ) ;
  }

