/*Master Task of Student Grades Problem*/
#include<stdio.h>
#include<stdlib.h>
#include<pvm3.h>

#define SLAVE "sstugra"
#define PROC 3
#define Students 100
#define Grades 10000

void main()
{
	int mytid,tids[PROC];
	int nproc = PROC;
	int no,i,j,who,msgtype;
	int ArrayOfGrades[Students][Grades];
        int StudentNames[Students];
        float Temp[Students/(PROC+1)];
	float Results[Students];
        float sum,TempGrade;
	int TempGradeInt,TempName;

	mytid = pvm_mytid();
	sum = 0;

        for(i=0;i<Students;i++)
		StudentNames[i]=i+1;

	/* Start Slave Tasks*/
	no = pvm_spawn(SLAVE,(char**)0,0,"",nproc,tids);
	if (no < nproc)
	{
		printf("Trouble spawning slaves \n");
		for(i=0;i<no;i++)
			pvm_kill(tids[i]);
		pvm_exit();
		exit(1);
	}

	/*Generating an Array of Student Grades in the Range 0-100*/
	for(i=0;i<Students;i++)
		for(j=0;j<Grades;j++)
		{
			ArrayOfGrades[i][j] = rand();
			ArrayOfGrades[i][j] = ArrayOfGrades[i][j]%100; 
		}

	/*BroadCast Data to Slaves*/
	pvm_initsend(PvmDataDefault);
	msgtype = 0;
	pvm_pkint(&nproc,1,1);
	pvm_pkint(tids,nproc,1);
	pvm_pkint(ArrayOfGrades,(Students*Grades),1);
	pvm_mcast(tids,nproc,msgtype);

        /*Calculating my Data*/
	for(i=0;i<(Students/(PROC+1));i++)
	{
		for(j=0;j<Grades;j++)
			sum += (ArrayOfGrades[i][j]*ArrayOfGrades[i][j]);
		Results[i] = sum / Grades;
		sum = 0;
	}


	/*Get Results from Slaves*/
	msgtype = 5;
	for(i=0;i<nproc;i++)
	{
		pvm_recv(-1,msgtype);
		pvm_upkint(&who,1,1);
		pvm_upkfloat(Temp,1,1);
                for(j=0;j<(Students/(PROC+1));j++)
                	Results[who*(Students/(PROC+1))+j] = Temp[j];
	}

        /*Swapping the Grades*/
        for(j=0;j<Students-1;j++)
        {
   	for(i=j+1;i<Students;i++)
	   	if(Results[j] < Results[i])
   	        {
      		TempGrade = Results[j];
         	Results[j] = Results[i];
		Results[i] = TempGrade;
                TempName = StudentNames[j];
         	StudentNames[j] = StudentNames[i];
		StudentNames[i] = TempName;
                }
        }

        /*Calculating the FNS scores*/
        for(i=0;i<(Students*0.10);i++)
		Results[i] = 4;
        for(i=(Students*0.10);i<(Students*0.30);i++)
		Results[i] = 3;
        for(i=(Students*0.30);i<(Students*0.60);i++)
		Results[i] = 2;
        for(i=(Students*0.60);i<(Students*0.80);i++)
		Results[i] = 1;
        for(i=(Students*0.80);i<(Students*1.00);i++)
		Results[i] = 0;

        /*Printing the FNS scores sorted by FNS scores*/
        printf("\nFNS = 4.0, \n Students :");
        for(i=0;i<Students;i++)
		if(Results[i] == 4)
			printf(",%d",StudentNames[i]);
        printf("\nFNS = 3.0, \n Students :");
        for(i=0;i<Students;i++)
		if(Results[i] == 3)
			printf(",%d",StudentNames[i]);
        printf("\nFNS = 2.0, \n Students :");
        for(i=0;i<Students;i++)
		if(Results[i] == 2)
			printf(",%d",StudentNames[i]);
        printf("\nFNS = 1.0, \n Students :");
        for(i=0;i<Students;i++)
		if(Results[i] == 1)
			printf(",%d",StudentNames[i]);
        printf("\nFNS = 0.0, \n Students :");
        for(i=0;i<Students;i++)
		if(Results[i] == 0)
			printf(",%d",StudentNames[i]);

        /*Swapping the Student Names*/
        for(j=0;j<Students-1;j++)
        {
   	     for(i=j+1;i<Students;i++)
	     {
	   	if(StudentNames[j] > StudentNames[i])
   	        {
      		TempGradeInt = Results[j];
         	Results[j] = Results[i];
		Results[i] = TG;
                TempName = StudentNames[j];
         	StudentNames[j] = StudentNames[i];
		StudentNames[i] = TempName;
                } 
	     }
        }

	/*Printing the list of FNS scores sorted by student*/
	for(i=0;i<Students;i++)
		printf("\nStudent : %d , FNS : %d ",StudentNames[i] , Results[i]);

        printf("\n");

       /*Program Finished*/
       pvm_exit();
}
