#include <stdio.h>
#include <stdlib.h>
#include <pvm3.h>
 
#define SLAVENAME "evennums"
#define PROC 4
#define NELEM 32
 
main()
  {
  int isodd;
  int totalodd = 0 ;
  int mytid ;                  /* my task id */
  int tids[ 4 ];
  int n = NELEM ;              /* number of data elements */
  int nproc = PROC ;           /* number of processes */
  int numt, i, j, who, msgtype ;
  int data[ 8 ] ;            /* data array */
  char fn[ 255 ] ;             /* array used for path name */
  FILE *fp;                    /* pointer to the input file */
 
  /* Enroll In PVM */
  mytid = pvm_mytid() ;
 
  /* Start Slave Tasks */
  numt = pvm_spawn( SLAVENAME, (char**)0, 0, "", nproc, tids ) ;
  if ( numt < nproc )
    {
      printf( "Trouble spawning slaves. Aborting. Error codes are: \n" ) ;
      for ( i=numt ; i<nproc ; i++ )
        printf( "TID %d %d\n", i, tids[ i ] ) ;
      for ( i = 0 ; i < numt ; i++ )
        pvm_kill( tids[ i ] ) ;
      pvm_exit() ;
      exit( 1 ) ;
    }
 
  /* Get Proper Path For Input File */
  strcpy( fn, getenv( "HOME" ) ) ;
  strcat( fn, "/pvm3/bin/SUN4SOL2/one.txt" ) ;
 
  /* Open Input File and Initialize Data */
  if ( ( fp = fopen( fn, "r" ) ) == NULL )
    {
      printf("Can't open the input file: %s\n\n", fn);
      exit(1);
    }
  for ( i=0; i<nproc; i++ )
  {
    for( j=0; j < ( n / nproc ) ; ++j)
    {
      fscanf( fp, "%d", &data[ j ] ) ;
    }
    pvm_initsend(PvmDataDefault);
    pvm_pkint(data, (n / nproc ), 1);
    pvm_send(tids[i],1);
  }
  fclose(fp);
  /* Wait For Results From The Slaves */
  msgtype = 5 ;
  for ( i=0; i < nproc; i++ )  
  {
      pvm_recv(-1, msgtype);
      pvm_upkint(&isodd, 1, 1);
      totalodd = totalodd + isodd ;
  }
  if ( ( totalodd % 2 ) == 0 )
  {
    printf ( "\nThere are even number of 1s\n") ;
  }
  else
  {
    if ( ( fp = fopen( fn, "a" ) ) == NULL )
    {
      printf("Can't open the file for append operation: %s\n\n", fn);
      exit(1);
    }
    fprintf( fp, "1");
    fclose( fp );
    printf( " \nThere are odd number of 1s\n");
    printf( " \nA 1 is appended to the end of file \n");
  }
      
  /* Program Finished. Exit PVM */
  pvm_exit() ;
  return( 0 ) ;
  }

