#include <stdio.h>
#include <math.h>
#include <pvm3.h>

#define PROC 10
#define f(x) ((x)+sin(1.0/(x)))

main(int argc, char *argv[])
{
   int mytid; 
   int master;
   int tids[PROC];              /* slave task ids */
   int nproc = PROC;            /* number of processes */
   float a;
   float b;
   int n;
   float x;
   float region, start, end, d, area, totarea=0.0;
   int numt, i, whoami;

   /* Enroll In PVM */
   mytid = pvm_mytid();

   master=pvm_parent();

   /* Start Slave Tasks */
   if (master==PvmNoParent)
   {
      numt = pvm_spawn(argv[0], (char**)0, 0, "", nproc, tids);
      if (numt < nproc)
      {
         printf("Trouble spawning slaves. Aborting. Error codes are: \n");
         for (i=numt; i<nproc; i++)
            printf("TID %d %d\n", i, tids[i]);
         for (i=0; i<numt; i++)
            pvm_kill(tids[i]);
         pvm_exit();
         exit(1);
      }
      /* Broadcast tids To Slaves */ 
      pvm_initsend(PvmDataDefault);
      pvm_pkint(tids, nproc, 1);
      pvm_mcast(tids, nproc, 0);

      for (i=0; i<nproc; i++)
      {
         pvm_recv(-1, 2);
         pvm_upkint(&numt, 1, 1);
         pvm_upkfloat(&area, 1, 1);
         printf("Area calculated by the %d.processor = %f\n", numt, area);
         totarea+=area;
      }
      printf("Total area = %f\n", totarea); 
   }
   else
   {
      /* Receive tids From Master */
      pvm_recv(-1, 0);
      pvm_upkint(tids, nproc, 1);

      /* Determine Which Slave I Am (0 -- nproc-1) */
      for (i=0; i<nproc; i++)
         if(mytid==tids[i])
            whoami=i;

      a=0.01;
      b=1.0;
      n=100;
      region=(b-a)/nproc;
      start=a+region*whoami;
      end=start+region;
      d=(b-a)/n;
      area=0.0;
      for(x=start;x<end;x=x+d)
         area+=f(x);
      area*=d;
      pvm_initsend(PvmDataDefault);
      pvm_pkint(&whoami, 1, 1);
      pvm_pkfloat(&area, 1, 1);
      pvm_send(master, 2);
   }

   /* Program Finished. Exit PVM */
   pvm_exit();
   return(0);
}

