#include <stdio.h>
#include <pvm3.h>
#include <math.h>

#define PROC 10
#define f(x) ((x)*(x)-3*(x)+2)
/*#define f(x) ((x))*/

main(int argc, char *argv[])
{
   int mytid; 
   int master;
   int tids[PROC];              /* slave task ids */
   int nproc = PROC;            /* number of processes */
   float a,a0;
   float b,b0;
   float x,error;
   float region, start, end;
   int found;
   int numt, i, whoami;

   /* Enroll In PVM */
   mytid = pvm_mytid();

   master=pvm_parent();

   /* Start Slave Tasks */
   if (master==PvmNoParent)
   {
      numt = pvm_spawn(argv[0], (char**)0, 0, "", nproc, tids);
      if (numt < nproc)
      {
         printf("Trouble spawning slaves. Aborting. Error codes are: \n");
         for (i=numt; i<nproc; i++)
            printf("TID %d %d\n", i, tids[i]);
         for (i=0; i<numt; i++)
            pvm_kill(tids[i]);
         pvm_exit();
         exit(1);
      }
      /* Broadcast tids To Slaves */ 
      pvm_initsend(PvmDataDefault);
      pvm_pkint(tids, nproc, 1);
      pvm_mcast(tids, nproc, 0);

      for (i=0; i<nproc; i++)
      {
         pvm_recv(-1, 2);
         pvm_upkint(&numt, 1, 1);
         pvm_upkint(&found, 1, 1);
         pvm_upkfloat(&x, 1, 1);
         if (found==1)
            printf("Zero crossing found by the %d.processor = %f\n", numt, x);
      }
   }
   else
   {
      /* Receive tids From Master */
      pvm_recv(-1, 0);
      pvm_upkint(tids, nproc, 1);

      /* Determine Which Slave I Am (0 -- nproc-1) */
      for (i=0; i<nproc; i++)
         if(mytid==tids[i])
            whoami=i;

      a0=3.0;
      b0=1.5;
      error=0.00001;
      region=(b0-a0)/nproc;
      start=a0+region*whoami;
      end=start+region;
      found=0;
      a=start;
      b=end;
      x=(a+b)/2.0;
      i=0;
      while ((fabs(f(x))>=error) && (i<1000))
      {
         if (f(a)*f(x)>0)
             a=x;
         else
             b=x;
         x=(a+b)/2.0;
         i++;
      }

      if (fabs(f(x))<error)
         found=1;

      pvm_initsend(PvmDataDefault);
      pvm_pkint(&whoami, 1, 1);
      pvm_pkint(&found, 1, 1);
      pvm_pkfloat(&x, 1, 1);
      pvm_send(master, 2);
   }

   /* Program Finished. Exit PVM */
   pvm_exit();
   return(0);
}

