#include <stdio.h>
#include <pvm3.h>

#define PROC 4

main(int argc, char *argv[])
{
   int mytid;                   /* my task id */
   int master;
   int tids[PROC];              /* slave task ids */
   int nproc = PROC;            /* number of processes */
   int yin, yout;
   int x[PROC]={2,4,6,8}, a[PROC]={3,5,7,9};
   int numt, i, whoami;

   /* Enroll In PVM */
   mytid = pvm_mytid();
   master=pvm_parent();

   /* Start Slave Tasks */
   if (master==PvmNoParent)
   {
      numt = pvm_spawn(argv[0], (char**)0, 0, "", nproc, tids);
      if (numt < nproc)
      {
         printf("Trouble spawning slaves. Aborting. Error codes are: \n");
         for (i=numt; i<nproc; i++)
            printf("TID %d %d\n", i, tids[i]);
         for (i=0; i<numt; i++)
            pvm_kill(tids[i]);
         pvm_exit();
         exit(1);
      }

      /* Broadcast tids To Slaves */ 
      pvm_initsend(PvmDataDefault);
      pvm_pkint(tids, nproc, 1);
      pvm_mcast(tids, nproc, 0);

      /* Wait For Result From The Last Slave */
      pvm_recv(tids[nproc-1], 1);
      pvm_upkint(&yout, 1, 1);
      printf("%d\n", yout);   /* 140 */
   }
   else
   {
      /* Receive tids From Master */
      pvm_recv(-1, 0);
      pvm_upkint(tids, nproc, 1);
   
      /* Determine Which Slave I Am (0 -- nproc-1) */
      for (i=0; i<nproc; i++)
         if(mytid==tids[i])
            whoami=i;
   
      /* Input To The Pipeline */
      if(whoami>0)
      {
         pvm_recv(tids[whoami-1], 2);
         pvm_upkint(&yin, 1, 1);
      }
      yout=yin+a[whoami]*x[whoami];
   
      /* Output From The Pipeline */
      if(whoami<nproc-1)
      {
         pvm_initsend(PvmDataDefault);
         pvm_pkint(&yout, 1, 1);
         pvm_send(tids[whoami+1], 2);
      }
   
      /* Send Result To The Master */
      if (whoami==nproc-1)
      {
         pvm_initsend(PvmDataDefault);
         pvm_pkint(&yout, 1, 1);
         pvm_send(master, 1);
      }
   }

   /* Program Finished. Exit PVM */
   pvm_exit();
   return(0);
}

